std::is_volatile(3)

NAME
std::is_volatile - std::is_volatile

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_volatile;
   If T is a volatile-qualified type (that is, volatile, or const volatile), provides
   the member constant value equal to true. For any other type, value is false.
   The behavior of a program that adds specializations for is_volatile
   or is_volatile_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_volatile_v = is_volatile<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a volatile-qualified type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   template<class T> struct is_volatile : std::false_type {};
   template<class T> struct is_volatile<volatile T> : std::true_type {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 int main()
 {
     std::cout << std::boolalpha;
     std::cout << std::is_volatile<int>::value << '\n';
     std::cout << std::is_volatile<volatile int>::value << '\n';
 }

Output:
 false
 true

See also
   is_const checks if a type is const-qualified
   (C++11) (class template)